// FFT.NET src ver.20071029

using System;

namespace WonderRabbitProject.Math
{
    static public class Constants
    {
        //萔
        public const double PIx2 = System.Math.PI * 2d;
    }
    /// <summary>
    /// fNX
    /// </summary>
    public class Complex
    {
        /// <summary>
        /// 
        /// </summary>
        public double r;
        /// <summary>
        /// 
        /// </summary>
        public double i;
        
        /// <summary>
        /// ==0d̕fł܂
        /// </summary>
        public Complex()
        {
            r = i = 0d;
        }
        
        /// <summary>
        /// 1.2+3.7i ̂悤ɕ
        /// </summary>
        /// <returns>lɉǂȕ\</returns>
        public override string ToString()
        {
            return r.ToString() + ((i < 0d) ? "" : "+") + i.ToString() + "i";
        }
        
        /// <summary>
        /// Ƌw肵ĕf܂
        /// </summary>
        /// <param name="cr"></param>
        /// <param name="ci"></param>
        public Complex(double cr, double ci)
        {
            r = cr;
            i = ci;
        }
        /// <summary>
        /// m
        /// </summary>
        public double norm
        {
            get
            {
                return r * r + i * i;
            }
        }
        /// <summary>
        /// Βl
        /// </summary>
        public double abs
        {
            get
            {
                return System.Math.Sqrt(norm);
            }
        }
        /// <summary>
        /// m̓
        /// </summary>
        public double pow2
        {
            get
            {
                return System.Math.Pow(norm, 2);
            }
        }
        public static Complex raim(Complex a, Complex b)
        {
            return new Complex(a.r + b.r, a.i - b.i);
        }
        public static Complex rmia(Complex a, Complex b)
        {
            return new Complex(a.r - b.r, a.i + b.i);
        }
        /// <summary>
        /// f̃GNX|lV
        /// </summary>
        /// <param name="c">f</param>
        /// <returns>GNX|lVf</returns>
        public static Complex Exp(Complex c)
        {
            double a = System.Math.Exp(c.r);
            return new Complex(a * System.Math.Cos(c.i), a * System.Math.Sin(c.i));
        }
        /// <summary>
        /// 0dȕf
        /// </summary>
        public static Complex Zero
        {
            get
            {
                return new Complex(0d, 0d);
            }
        }
        /// <summary>
        /// 1dA0d̕f
        /// </summary>
        public static Complex One
        {
            get
            {
                return new Complex(1d, 0d);
            }
        }
        /// <summary>
        /// 0dA1d̕f
        /// </summary>
        public static Complex im
        {
            get
            {
                return new Complex(0d, 1d);
            }
        }
        /// <summary>
        /// f̋
        /// </summary>
        /// <param name="a">f</param>
        /// <returns>𕡑f</returns>
        public static Complex operator ~(Complex a)
        {
            return new Complex(a.r, -a.i);
        }
        /// <summary>
        /// f̑Z
        /// </summary>
        /// <param name="a">镡f</param>
        /// <param name="b">f</param>
        /// <returns>Z</returns>
        public static Complex operator +(Complex a, Complex b)
        {
            return new Complex(a.r + b.r, a.i + b.i);
        }
        /// <summary>
        /// f̈Z
        /// </summary>
        /// <param name="a">镡f</param>
        /// <param name="b">f</param>
        /// <returns>Z</returns>
        public static Complex operator -(Complex a, Complex b)
        {
            return new Complex(a.r - b.r, a.i - b.i);
        }
        /// <summary>
        /// f̊|Z
        /// </summary>
        /// <param name="a">|镡f</param>
        /// <param name="b">|镡f</param>
        /// <returns>|Z</returns>
        public static Complex operator *(Complex a, Complex b)
        {
            return new Complex(a.r * b.r - a.i * b.i, a.r * b.i + b.r * a.i);
        }
        /// <summary>
        /// f̊Z
        /// </summary>
        /// <param name="a">镡f</param>
        /// <param name="b">镡f</param>
        /// <returns>Z</returns>
        public static Complex operator /(Complex a, Complex b)
        {
            return new Complex(a.r * b.r - a.i * b.i, 0);
        }
    }
    
    namespace OrthogonalTransform
    {
        /// <summary>
        /// ֐
        /// </summary>
        static public class WindowFunction
        {
            //֐cDelegateƂĎgz
            //ꉞ
            //S(N^)g\ԕ\ၨڋ߂ԕω̌oړĂ̎ɂǁ[
            //Sׂ(u})g\ၕԕ\ڋ߂g̐M̕ړĂ̎ɂǁ[
            //RpNgT|[g([)Ă遨Ul̘Aߎɂ悢XyNgւ̂UmCY̏o}
            /// <summary>
            /// `
            /// </summary>
            /// <param name="n">m̎f[^iԖڂ̒ln</param>
            /// <param name="i">m̎f[^iԖڂ̒ln</param>
            /// <param name="m">m̎f[^iԖڂ̒ln</param>
            /// <returns>֐Kpl</returns>
            public static double Window_Rectanguler(double n, int i, int m)
            {
                return n;
            }
            /// <summary>
            /// KEXAől1Al0.5ƂȂʒuԕm/2
            /// </summary>
            /// <param name="n">m̎f[^iԖڂ̒ln</param>
            /// <param name="i">m̎f[^iԖڂ̒ln</param>
            /// <param name="m">m̎f[^iԖڂ̒ln</param>
            /// <returns>֐Kpl</returns>
            public static double Window_Gaussian(double n, int i, int m)
            {
                double MmOp2 = (double)(m - 1) / 2d;
                return n * System.Math.Exp(-System.Math.Pow((double)i - MmOp2, 2d) / System.Math.Pow(MmOp2, 2d));
            }
            /// <summary>
            /// g(vZʂ̓njOɓ)
            /// </summary>
            /// <param name="n">m̎f[^iԖڂ̒ln</param>
            /// <param name="i">m̎f[^iԖڂ̒ln</param>
            /// <param name="m">m̎f[^iԖڂ̒ln</param>
            /// <returns>֐Kpl</returns>
            public static double Window_HalfSineSquare(double n, int i, int m)
            {
                return n * System.Math.Pow(System.Math.Sin(System.Math.PI * i / (m - 1)), 2d);
            }
            /// <summary>
            /// ubN}
            /// </summary>
            /// <param name="n">m̎f[^iԖڂ̒ln</param>
            /// <param name="i">m̎f[^iԖڂ̒ln</param>
            /// <param name="m">m̎f[^iԖڂ̒ln</param>
            /// <returns>֐Kpl</returns>
            public static double Window_Blackman(double n, int i, int m)
            {
                double PIx2xA = WonderRabbitProject.Math.Constants.PIx2 * (double)i / (double)(m - 1);
                return n * (0.42d - 0.5d * System.Math.Cos(PIx2xA) + 0.08d * System.Math.Cos(2 * PIx2xA));
            }
            /// <summary>
            /// njO
            /// </summary>
            /// <param name="n">m̎f[^iԖڂ̒ln</param>
            /// <param name="i">m̎f[^iԖڂ̒ln</param>
            /// <param name="m">m̎f[^iԖڂ̒ln</param>
            /// <returns>֐Kpl</returns>
            public static double Window_Hanning(double n, int i, int m)
            {
                return n * (0.5d - 0.5d * System.Math.Cos(WonderRabbitProject.Math.Constants.PIx2 * (double)i / (double)(m - 1)));
            }
            /// <summary>
            /// n~O
            /// </summary>
            /// <param name="n">m̎f[^iԖڂ̒ln</param>
            /// <param name="i">m̎f[^iԖڂ̒ln</param>
            /// <param name="m">m̎f[^iԖڂ̒ln</param>
            /// <returns>֐Kpl</returns>
            public static double Window_Hamming(double n, int i, int m)
            {
                return n * (0.54d - 0.46d * System.Math.Cos(WonderRabbitProject.Math.Constants.PIx2 * (double)i / (double)(m - 1)));
            }
        }

        /// <summary>
        /// t[GϊNX
        /// ̃NXDFTASY͈ȉ̃TCgŌJĂ
        /// ̂WonderRabbitC#pɈڐAłB
        /// Ooura's Mathematical Software Packages
        /// http://www.kurims.kyoto-u.ac.jp/~ooura/index-j.html
        /// </summary>
        static public class FourieTransform
        {
            /// <summary>
            /// vZp
            /// ċAf2ȊȎfɑꍇfalseA1ɂȂ܂2ȊȎftrue
            /// </summary>
            /// <param name="n"></param>
            /// <returns></returns>
            public static bool Is2Power(int n)
            {
                return n.Equals(2) ? true : (n % 2 == 0) ? Is2Power(n / 2) : false;
            }
            /// <summary>
            /// fUt[Gϊ(SplitRadix)
            /// </summary>
            /// <param name="n"></param>
            /// <param name="a">f̔z</param>
            /// <returns>Wϊꂽ</returns>
            public static Complex[] SplitRadixFourieTransform(int n, Complex[] a)
            {
                int m, mq, irev, i, j, j1, j2, j3, k;
                double theta;//, w1r, w1i, w3r, w3i;
                Complex w1 = new Complex();
                Complex w3 = new Complex();
                Complex[] x = new Complex[4] {
                    new Complex(),
                    new Complex(),
                    new Complex(),
                    new Complex(),
                };//x0r, x0i, x1r, x1i, x3r, x3i;

                /* ---- scrambler ---- */
                i = 0;
                for (j = 1; j < n - 1; j++)
                {
                    for (k = n >> 1; k > (i ^= k); k >>= 1) ;
                    if (j < i)
                    {
                        x[0].r = a[j].r;
                        x[0].i = a[j].i;
                        a[j].r = a[i].r;
                        a[j].i = a[i].i;
                        a[i].r = x[0].r;
                        a[i].i = x[0].i;
                    }
                }
                /* ---- L shaped butterflies ---- */
                theta = -2 * System.Math.Atan(1.0d) / n;
                for (m = 4; m <= n; m <<= 1)
                {
                    mq = m >> 2;
                    /* ---- W == 1 ---- */
                    for (k = mq; k >= 1; k >>= 2)
                    {
                        for (j = mq - k; j < mq - (k >> 1); j++)
                        {
                            j1 = j + mq;
                            j2 = j1 + mq;
                            j3 = j2 + mq;
                            x[1].r = a[j].r - a[j1].r;
                            x[1].i = a[j].i - a[j1].i;
                            a[j].r += a[j1].r;
                            a[j].i += a[j1].i;
                            x[3].r = a[j3].r - a[j2].r;
                            x[3].i = a[j3].i - a[j2].i;
                            a[j2].r += a[j3].r;
                            a[j2].i += a[j3].i;
                            a[j1].r = x[1].r - x[3].i;
                            a[j1].i = x[1].i + x[3].r;
                            a[j3].r = x[1].r + x[3].i;
                            a[j3].i = x[1].i - x[3].r;
                        }
                    }
                    if (m == n) continue;
                    /* ---- W == exp(-pi*i/4) ---- */
                    irev = n >> 1;
                    w1.r = System.Math.Cos(theta * irev);
                    for (k = mq; k >= 1; k >>= 2)
                    {
                        for (j = m + mq - k; j < m + mq - (k >> 1); j++)
                        {
                            j1 = j + mq;
                            j2 = j1 + mq;
                            j3 = j2 + mq;
                            x[1].r = a[j].r - a[j1].r;
                            x[1].i = a[j].i - a[j1].i;
                            a[j].r += a[j1].r;
                            a[j].i += a[j1].i;
                            x[3].r = a[j3].r - a[j2].r;
                            x[3].i = a[j3].i - a[j2].i;
                            a[j2].r += a[j3].r;
                            a[j2].i += a[j3].i;
                            x[0].r = x[1].r - x[3].i;
                            x[0].i = x[1].i + x[3].r;
                            a[j1].r = w1.r * (x[0].r + x[0].i);
                            a[j1].i = w1.r * (x[0].i - x[0].r);
                            x[0].r = x[1].r + x[3].i;
                            x[0].i = x[1].i - x[3].r;
                            a[j3].r = w1.r * (-x[0].r + x[0].i);
                            a[j3].i = w1.r * (-x[0].i - x[0].r);
                        }
                    }
                    /* ---- W != 1, exp(-pi*i/4) ---- */
                    for (i = 2 * m; i < n; i += m)
                    {
                        for (k = n >> 1; k > (irev ^= k); k >>= 1) ;
                        w1.r = System.Math.Cos(theta * irev);
                        w1.i = System.Math.Sin(theta * irev);
                        w3.r = System.Math.Cos(theta * 3 * irev);
                        w3.i = System.Math.Sin(theta * 3 * irev);
                        for (k = mq; k >= 1; k >>= 2)
                        {
                            for (j = i + mq - k; j < i + mq - (k >> 1); j++)
                            {
                                j1 = j + mq;
                                j2 = j1 + mq;
                                j3 = j2 + mq;
                                x[1].r = a[j].r - a[j1].r;
                                x[1].i = a[j].i - a[j1].i;
                                a[j].r += a[j1].r;
                                a[j].i += a[j1].i;
                                x[3].r = a[j3].r - a[j2].r;
                                x[3].i = a[j3].i - a[j2].i;
                                a[j2].r += a[j3].r;
                                a[j2].i += a[j3].i;
                                x[0].r = x[1].r - x[3].i;
                                x[0].i = x[1].i + x[3].r;
                                a[j1].r = w1.r * x[0].r - w1.i * x[0].i;
                                a[j1].i = w1.r * x[0].i + w1.i * x[0].r;
                                x[0].r = x[1].r + x[3].i;
                                x[0].i = x[1].i - x[3].r;
                                a[j3].r = w3.r * x[0].r - w3.i * x[0].i;
                                a[j3].i = w3.r * x[0].i + w3.i * x[0].r;
                            }
                        }
                    }
                }
                /* ---- radix 2 butterflies ---- */
                mq = n >> 1;
                for (k = mq; k >= 1; k >>= 2)
                {
                    for (j = mq - k; j < mq - (k >> 1); j++)
                    {
                        j1 = mq + j;
                        x[0].r = a[j].r - a[j1].r;
                        x[0].i = a[j].i - a[j1].i;
                        a[j].r += a[j1].r;
                        a[j].i += a[j1].i;
                        a[j1].r = x[0].r;
                        a[j1].i = x[0].i;
                    }
                }
                return a;
            }
        }
    }
}
